// Code generated by client-gen. DO NOT EDIT.

package v1

import (
	"context"
	"time"

	v1 "github.com/dask/dask-kubernetes/v2025/dask_kubernetes/operator/go_client/pkg/apis/kubernetes.dask.org/v1"
	scheme "github.com/dask/dask-kubernetes/v2025/dask_kubernetes/operator/go_client/pkg/client/clientset/versioned/scheme"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// DaskClustersGetter has a method to return a DaskClusterInterface.
// A group's client should implement this interface.
type DaskClustersGetter interface {
	DaskClusters(namespace string) DaskClusterInterface
}

// DaskClusterInterface has methods to work with DaskCluster resources.
type DaskClusterInterface interface {
	Create(ctx context.Context, daskCluster *v1.DaskCluster, opts metav1.CreateOptions) (*v1.DaskCluster, error)
	Update(ctx context.Context, daskCluster *v1.DaskCluster, opts metav1.UpdateOptions) (*v1.DaskCluster, error)
	UpdateStatus(ctx context.Context, daskCluster *v1.DaskCluster, opts metav1.UpdateOptions) (*v1.DaskCluster, error)
	Delete(ctx context.Context, name string, opts metav1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts metav1.DeleteOptions, listOpts metav1.ListOptions) error
	Get(ctx context.Context, name string, opts metav1.GetOptions) (*v1.DaskCluster, error)
	List(ctx context.Context, opts metav1.ListOptions) (*v1.DaskClusterList, error)
	Watch(ctx context.Context, opts metav1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts metav1.PatchOptions, subresources ...string) (result *v1.DaskCluster, err error)
	DaskClusterExpansion
}

// daskClusters implements DaskClusterInterface
type daskClusters struct {
	client rest.Interface
	ns     string
}

// newDaskClusters returns a DaskClusters
func newDaskClusters(c *KubernetesV1Client, namespace string) *daskClusters {
	return &daskClusters{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the daskCluster, and returns the corresponding daskCluster object, and an error if there is any.
func (c *daskClusters) Get(ctx context.Context, name string, options metav1.GetOptions) (result *v1.DaskCluster, err error) {
	result = &v1.DaskCluster{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("daskclusters").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of DaskClusters that match those selectors.
func (c *daskClusters) List(ctx context.Context, opts metav1.ListOptions) (result *v1.DaskClusterList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1.DaskClusterList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("daskclusters").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested daskClusters.
func (c *daskClusters) Watch(ctx context.Context, opts metav1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("daskclusters").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a daskCluster and creates it.  Returns the server's representation of the daskCluster, and an error, if there is any.
func (c *daskClusters) Create(ctx context.Context, daskCluster *v1.DaskCluster, opts metav1.CreateOptions) (result *v1.DaskCluster, err error) {
	result = &v1.DaskCluster{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("daskclusters").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(daskCluster).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a daskCluster and updates it. Returns the server's representation of the daskCluster, and an error, if there is any.
func (c *daskClusters) Update(ctx context.Context, daskCluster *v1.DaskCluster, opts metav1.UpdateOptions) (result *v1.DaskCluster, err error) {
	result = &v1.DaskCluster{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("daskclusters").
		Name(daskCluster.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(daskCluster).
		Do(ctx).
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *daskClusters) UpdateStatus(ctx context.Context, daskCluster *v1.DaskCluster, opts metav1.UpdateOptions) (result *v1.DaskCluster, err error) {
	result = &v1.DaskCluster{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("daskclusters").
		Name(daskCluster.Name).
		SubResource("status").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(daskCluster).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the daskCluster and deletes it. Returns an error if one occurs.
func (c *daskClusters) Delete(ctx context.Context, name string, opts metav1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("daskclusters").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *daskClusters) DeleteCollection(ctx context.Context, opts metav1.DeleteOptions, listOpts metav1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("daskclusters").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched daskCluster.
func (c *daskClusters) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts metav1.PatchOptions, subresources ...string) (result *v1.DaskCluster, err error) {
	result = &v1.DaskCluster{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("daskclusters").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
